#include <stdio.h>
#include <string.h>

struct
{
	unsigned short offset;
	unsigned char origvalue;
	unsigned char newvalue;
} patches[] =
{
	{ 0xBC3, 0x0F, 0x90 },
	{ 0xBC4, 0x84, 0x90 },
	{ 0xBC5, 0x97, 0x90 },
	{ 0xBC6, 0x00, 0x90 },
	{ 0xBC7, 0x00, 0x90 },
	{ 0xBC8, 0x00, 0x90 },
	{ 0xC03, 0x75, 0x90 },
	{ 0xC04, 0x5B, 0x90 },
	{ 0xC15, 0x75, 0x90 },
	{ 0xC16, 0x49, 0x90 },
};

#define NUMPATCHES (sizeof(patches)/sizeof(*patches))

int main(int argc, char **argv)
{
	FILE *f;
	unsigned char val;
	int i;
	int ret;

	ret = 1;

	f = fopen("ezquake-security.so", "r+");
	if (f)
	{
		for(i=0;i<NUMPATCHES;i++)
		{
			if (fseek(f, patches[i].offset, SEEK_SET) == 0)
			{
				if (fread(&val, 1, 1, f) != 1 || val != patches[i].origvalue)
				{
					printf("Unknown source file!\n");
					break;
				}
			}
			else
			{
				printf("Unable to seek to the correct position in the file\n");
				break;
			}
		}

		if (i == NUMPATCHES)
		{
			for(i=0;i<NUMPATCHES;i++)
			{
				if (fseek(f, patches[i].offset, SEEK_SET) == 0)
				{
					val = patches[i].newvalue;
					if (fwrite(&val, 1, 1, f) != 1)
					{
						printf("Unable to write new path\n");
						break;
					}
				}
				else
				{
					printf("Unable to seek to the correct position in the file\n");
					break;
				}
			}

			if (i == NUMPATCHES)
				ret = 0;
		}

		fclose(f);
	}
	else
		printf("Unable to open \"ezquake-security.so\"\n");

	if (ret == 0)
	{
		printf("Successfully patched file\n");
	}
	else
	{
		printf("Failed to patch file\n");
	}

	return ret;
}

